---
title: RegExp.prototype.dotAll
slug: Web/JavaScript/Reference/Global_Objects/RegExp/dotAll
tags:
  - Draft
  - JavaScript
  - Property
  - Prototype
  - Reference
  - RegExp
  - Regular Expressions
---
<p>{{JSRef}}</p>

<p>The <strong><code>dotAll</code></strong> property indicates whether or not the "<code>s</code>" flag is used with the regular expression. <code>dotAll</code> is a read-only property of an individual regular expression instance.</p>

<div>{{EmbedInteractiveExample("pages/js/regexp-prototype-dotall.html")}}</div>

<p>{{JS_Property_Attributes(0, 0, 1)}}</p>

<h2 id="Description">Description</h2>

<p>The value of <code>dotAll</code> is a {{JSxRef("Boolean")}} and <code>true</code> if the "<code>s</code>" flag was used; otherwise, <code>false</code>. The "<code>s</code>" flag indicates that the dot special character ("<code>.</code>") should additionally match the following line terminator ("newline") characters in a string, which it would not match otherwise:</p>

<ul>
 <li>U+000A LINE FEED (LF) ("<code>\n</code>")</li>
 <li>U+000D CARRIAGE RETURN (CR) ("<code>\r</code>")</li>
 <li>U+2028 LINE SEPARATOR</li>
 <li>U+2029 PARAGRAPH SEPARATOR</li>
</ul>

<p>This effectively means the dot will match any character on the Unicode Basic Multilingual Plane (BMP). To allow it to match astral characters, the "<code>u</code>" (unicode) flag should be used. Using both flags in conjunction allows the dot to match any Unicode character, without exceptions.</p>

<p>You cannot change this property directly.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_dotAll">Using <code>dotAll</code></h3>

<pre class="brush: js">var str1 = 'bar\nexample foo example';

var regex1 = new RegExp('bar.example','s');

console.log(regex1.dotAll); // Output: true

console.log(str1.replace(regex1,'')); // Output: foo example

var str2 = 'bar\nexample foo example';

var regex2 = new RegExp('bar.example');

console.log(regex2.dotAll); // Output: false

console.log(str2.replace(regex2,'')); // Output: bar
                                      //         example foo example</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-regexp.prototype.dotAll', 'RegExp.prototype.dotAll')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.builtins.RegExp.dotAll")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{JSxRef("RegExp.lastIndex")}}</li>
 <li>{{JSxRef("RegExp.prototype.global")}}</li>
 <li>{{JSxRef("RegExp.prototype.ignoreCase")}}</li>
 <li>{{JSxRef("RegExp.prototype.multiline")}}</li>
 <li>{{JSxRef("RegExp.prototype.source")}}</li>
 <li>{{JSxRef("RegExp.prototype.sticky")}}</li>
 <li>{{JSxRef("RegExp.prototype.unicode")}}</li>
</ul>
